;;
;; MIT License
;;
;; Copyright (c) 2018 Thomas Chust
;;
;; Permission is hereby granted, free of charge, to any person obtaining a copy
;; of this software and associated documentation files (the "Software"), to deal
;; in the Software without restriction, including without limitation the rights
;; to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
;; copies of the Software, and to permit persons to whom the Software is
;; furnished to do so, subject to the following conditions:
;;
;; The above copyright notice and this permission notice shall be included in
;; all copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
;; AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
;; LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
;; OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
;; SOFTWARE.
;;

(module webview-content
  (char-set:no-js-escape write-js html-tag-rule write-html)
  (import
    scheme
    (chicken base)
    (chicken fixnum)
    (only srfi-1 every)
    (prefix (only utf8 string-length string-ref display) utf8-)
    (only srfi-13 string-pad)
    utf8-srfi-14
    (prefix unicode-char-sets unicode-)
    srfi-69)
  (include
    "content.scm"))

(module webview
  (webview?
   webview webview-terminate!
   webview-title-set! webview-fullscreen-set!
   webview-eval
   webview-style-set! webview-style-delete!
   webview-html-set! webview-html-delete!
   webview-dialog webview-log)
  (import
    scheme
    (chicken base)
    (chicken condition)
    (chicken fixnum)
    (chicken bitwise)
    (chicken foreign)
    (only (chicken port) call-with-output-string)
    (only (chicken memory) tagged-pointer? tag-pointer)
    (only (chicken gc) set-finalizer!)
    (only srfi-13 string-trim-both)
    srfi-18
    srfi-69
    webview-content)
  (foreign-declare
    "#include <webview.h>")
  (include
    "main.scm"))

;; vim: set ai et ts=4 sts=2 sw=2 ft=scheme: ;;
